---
updatedAt: 2026-09-08T10:21:10.000Z
agentTools:
  projectIndex: https://developers.tron.network/llms.txt
---

# GetProposalById

Queries proposal based on ID and returns proposal details.

## Related resources

* [Wallet Listproposals](https://developers.tron.network/reference/wallet-listproposals) — previous in this section
* [Proposalcreate](https://developers.tron.network/reference/proposalcreate) — next in this section
* [Committee and proposals](https://developers.tron.network/docs/committee) — proposal lifecycle, vote-and-withdraw rules, expiry semantics
* [Network parameters](https://developers.tron.network/docs/network-parameters) — parameters a proposal can modify

# OpenAPI definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "full-node-http-api",
    "version": "4.8.0"
  },
  "servers": [
    {
      "url": "https://api.shasta.trongrid.io",
      "description": "Shasta Testnet"
    },
    {
      "url": "https://nile.trongrid.io",
      "description": "Nile Testnet"
    },
    {
      "url": "https://api.trongrid.io",
      "description": "Mainnet (real assets)"
    }
  ],
  "components": {
    "schemas": {
      "NodeHttpBusinessError": {
        "title": "Error",
        "type": "object",
        "description": "When request processing fails, java-tron may return this format with HTTP 200; the `Error` field contains the error details.",
        "required": [
          "Error"
        ],
        "properties": {
          "Error": {
            "type": "string",
            "description": "Error text returned by java-tron."
          }
        },
        "examples": [
          {
            "Error": "Invalid request parameters."
          }
        ],
        "additionalProperties": false
      },
      "ProposalId": {
        "type": "int64",
        "description": "Unique ID for the chain proposal."
      },
      "CreateTime": {
        "type": "int64",
        "description": "Account creation timestamp, in milliseconds."
      },
      "Parameters": {
        "type": "map\\<int64, int64>",
        "description": "Proposed values for chain parameters, keyed by parameter ID."
      }
    }
  },
  "security": [
    {}
  ],
  "paths": {
    "/wallet/getproposalbyid": {
      "post": {
        "summary": "GetProposalById",
        "description": "Queries proposal based on ID and returns proposal details.",
        "operationId": "getproposalbyid",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "id": {
                    "type": "integer",
                    "default": "",
                    "format": "int32",
                    "description": "Unique ID for the chain proposal. For example:`1`."
                  },
                  "visible": {
                    "type": "boolean",
                    "description": "Optional. Set to `true` to format addresses in Base58; set to `false` for hex format. (Default: `false`)",
                    "default": ""
                  }
                },
                "required": [
                  "id"
                ]
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "When the request completes normally, the response body contains the endpoint result. If request processing raises an exception, the HTTP status may still be 200; in that case, the response body contains only the `Error` field.",
            "content": {
              "application/json": {
                "schema": {
                  "oneOf": [
                    {
                      "title": "Result",
                      "not": {
                        "type": "object",
                        "required": [
                          "Error"
                        ]
                      },
                      "type": "object",
                      "properties": {
                        "proposal_id": {
                          "$ref": "#/components/schemas/ProposalId",
                          "format": "int64"
                        },
                        "proposer_address": {
                          "type": "string",
                          "description": "Address of the proposal's creator."
                        },
                        "parameters": {
                          "$ref": "#/components/schemas/Parameters"
                        },
                        "expiration_time": {
                          "type": "integer",
                          "format": "int64",
                          "description": "Expiration time of the proposal. (Unit: millisecond)"
                        },
                        "create_time": {
                          "$ref": "#/components/schemas/CreateTime",
                          "format": "int64"
                        },
                        "approvals": {
                          "type": "array",
                          "items": {
                            "type": "string"
                          },
                          "description": "List of approver addresses."
                        },
                        "state": {
                          "type": "string",
                          "description": "State of the proposal. (Enum: `PENDING`, `DISAPPROVED`, `APPROVED`, `CANCELED`)state"
                        }
                      }
                    },
                    {
                      "$ref": "#/components/schemas/NodeHttpBusinessError"
                    }
                  ]
                },
                "examples": {
                  "Result": {
                    "value": "{}"
                  }
                }
              }
            }
          },
          "400": {
            "description": "400",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": "{}"
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {}
                }
              }
            }
          }
        },
        "deprecated": false,
        "security": [],
        "x-readme": {
          "code-samples": [
            {
              "language": "javascript",
              "code": "$.post('https://api.trongrid.io/wallet/getproposalbyid', {\"id\":1}, function(data) {\n    console.log(data);\n});"
            }
          ],
          "samples-languages": [
            "javascript"
          ]
        }
      }
    }
  },
  "x-readme": {
    "headers": [],
    "explorer-enabled": true,
    "proxy-enabled": true
  },
  "x-readme-fauxas": true
}
```